-- 战力对比详情窗口
Lua_ForceRatioTypeAttributeWindow = class("Lua_ForceRatioTypeAttributeWindow", Lua_Window);
function Lua_ForceRatioTypeAttributeWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_ForceRatioTypeAttributeWindow";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_ForceRatioTypeAttributeWindow:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ForceRatioTypeAttributeWindow:onClickGotoTxt()
	local bCloseOther = false;
	if self.ratioType == Lua_FriendUtil.POTENTIALRATIO or -- 潜能
		self.ratioType == Lua_FriendUtil.LEAGUELEVEL or -- 公会等级
		self.ratioType == Lua_FriendUtil.LEAGUESKILL  -- 公会技巧
	then
		bCloseOther = true;
	end
	local funcPathId_1 = DataCenter.friendUtil:getRatioCfgAtt(self.ratioType, 9);
	if funcPathId_1 ~= nil then
		DataCenter.funcPathUtil:gotoFunction(funcPathId_1, bCloseOther);
	end
end

function Lua_ForceRatioTypeAttributeWindow:showWin(param)
	self:superCall("showWin", param);

	if self.ratioType ~= param.type then
		if self.ratioPanel ~= nil then
			self.ratioPanel:dispose();
			self.ratioPanel = nil;
		end
	end
	self.ratioType = param.type;

	local panel;
	if self.ratioType == Lua_FriendUtil.POTENTIALRATIO then -- 潜能 
		panel = Lua_ForceRatioTypeAttributePotentialPanel;
	elseif self.ratioType == Lua_FriendUtil.COLLECTIONITEM then -- 藏品柜
		panel = Lua_ForceRatioTypeAttributeCollectionItemPanel;
	elseif self.ratioType == Lua_FriendUtil.HOMOLOGATORRATIO then -- 同调器 
		panel = Lua_ForceRatioTypeAttributeHomologatorPanel;
	elseif self.ratioType == Lua_FriendUtil.LEAGUESKILL then -- 公会技巧 
		panel = Lua_ForceRatioTypeAttributeLeagueSkillPanel;
	elseif self.ratioType == Lua_FriendUtil.LEAGUELEVEL then -- 公会等级
		panel = Lua_ForceRatioTypeAttributeLeagueLevelPanel;
	elseif self.ratioType == Lua_FriendUtil.PERSONTITLE then -- 称号
		panel = Lua_ForceRatioTypeAttributePersonTitlePanel;
	elseif self.ratioType == Lua_FriendUtil.ARTFACTRATIO then -- 神器对比
		panel = Lua_ForceRatioTypeAttributeArtfactPanel;
	end

	self.ratioPanel = panel.new(self.content);
	self.ratioPanel:setData(param, self.ratioType);
end

function Lua_ForceRatioTypeAttributeWindow:dispose()
	if self.ratioPanel ~= nil then
		self.ratioPanel:dispose();
		self.ratioPanel = nil;
	end
	self:superCall("dispose");
end









---------------------------------------------------------------
Lua_ForceRatioTypeAttributeItem = class("Lua_ForceRatioTypeAttributeItem", Lua_ListCell);
function Lua_ForceRatioTypeAttributeItem:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributeItem_skin");
end

function Lua_ForceRatioTypeAttributeItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ForceRatioTypeAttributeItem:dispose()
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeItem:setData(data)
	self.data = data;

	if data == nil then
		return;
	end

	self.itemBg:setAltas("common_altas_2", data.attr_icon_1);

	local str = LanUtil.formateStr(162027, data.show_name, data.showValue);
	self.descTxt.text = str;
end








---------------------------------------------------------------
Lua_ForceRatioTypeAttributeBasePanel = class("Lua_ForceRatioTypeAttributeBasePanel", Lua_DisplayObject);
function Lua_ForceRatioTypeAttributeBasePanel:ctor(p, skinName)
	self:superCall("ctor", p, skinName);
end

function Lua_ForceRatioTypeAttributeBasePanel:buildShowItem()
	self:superCall("buildShowItem");

	self.leftRatioList = Lua_DragList.new(self.content, 221, 188, Lua_AxisDefine.Vertical);
	self.leftRatioList:setListCell(Lua_ForceRatioTypeAttributeItem, 221, 36, 1);
	self.leftRatioList:setLocation(-215, 16);
	self.leftRatioList:setRectPivot(1);
	self.leftRatioList:setRectAnchor(1);
	self.leftRatioList:setCellSpacing(0, 10);


	self.rightRatioList = Lua_DragList.new(self.content, 221, 188, Lua_AxisDefine.Vertical);
	self.rightRatioList:setListCell(Lua_ForceRatioTypeAttributeItem, 221, 36, 1);
	self.rightRatioList:setLocation(146, 99);
	self.rightRatioList:setRectAnchor(1);
	self.rightRatioList:setRectPivot(1);
	self.rightRatioList:setCellSpacing(0, 10);

	self.itemHeight = 46;
end

function Lua_ForceRatioTypeAttributeBasePanel:dispose()
	if self.leftRatioList ~= nil then
		self.leftRatioList:dispose();
		self.leftRatioList = nil;
	end
	if self.rightRatioList ~= nil then
		self.rightRatioList:dispose();
		self.rightRatioList = nil;
	end

	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeBasePanel:setData(data, ratioType)
	self.ratioType = ratioType;

	if data == nil then
		return;
	end

	local leftArr = DataCenter.attributesUtil:getAttrArrByServer(data.self_prop_info.prop_list);
	local rightArr = DataCenter.attributesUtil:getAttrArrByServer(data.other_prop_info.prop_list);
	self.leftCount = leftArr:getSize();
	self.rightCount = rightArr:getSize();
	self.leftRatioList:setContentRect(221, self.itemHeight * self.leftCount);
	self.leftRatioList:setArrayData(leftArr);
	self.rightRatioList:setContentRect(221, self.itemHeight * self.rightCount);
	self.rightRatioList:setArrayData(rightArr);
end

function Lua_ForceRatioTypeAttributeBasePanel:onClickGotoTxt()
	local bCloseOther = false;
	if self.ratioType == Lua_FriendUtil.POTENTIALRATIO or -- 潜能
		self.ratioType == Lua_FriendUtil.LEAGUELEVEL or -- 公会等级
		self.ratioType == Lua_FriendUtil.LEAGUESKILL  -- 公会技巧
	then
		bCloseOther = true;
	end
	local funcPathId_1 = DataCenter.friendUtil:getRatioCfgAtt(self.ratioType, 9);
	if funcPathId_1 ~= nil then
		DataCenter.funcPathUtil:gotoFunction(funcPathId_1, bCloseOther);
	end
end











----------------------------------潜能----------------------------------------------
Lua_ForceRatioTypeAttributePotentialPanel = class("Lua_ForceRatioTypeAttributePotentialPanel", Lua_ForceRatioTypeAttributeBasePanel);
function Lua_ForceRatioTypeAttributePotentialPanel:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributePotentialPanel_skin");
end

function Lua_ForceRatioTypeAttributePotentialPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.gotoTxt:addClickFuntion(self, self.onClickGotoTxt);
end

function Lua_ForceRatioTypeAttributePotentialPanel:dispose()
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributePotentialPanel:setData(data, ratioType)
	self:superCall("setData", data, ratioType);
	if data == nil then
		return;
	end

	self.ratioType = ratioType;

	self.leftTitleTxt:setLangValue(162004);
	self.leftDescTxt_2:setLangValue(162024);
	self.leftDescTxt_4:setLangValue(162005);
	local id = data.self_prop_info ~= nil and data.self_prop_info.value or 101;
	id = tonumber(id);
	local roleFateVo = Lua_RoleFateVo.new(id);
	self.leftDescTxt.text = roleFateVo.name;
	self.leftDescTxt_3.text = LanUtil.formateStr(162026,data.self_prop_info.force or 0);

	self.rightTitleTxt:setLangValue(162004);
	self.rightDescTxt_2:setLangValue(162024);
	self.rightDescTxt_4:setLangValue(162005);
	id = data.other_prop_info ~= nil and data.other_prop_info.value or 101;
	id = tonumber(id);
	roleFateVo = Lua_RoleFateVo.new(id);
	self.rightDescTxt.text = roleFateVo.name;
	self.rightDescTxt_3.text = LanUtil.formateStr(162026, data.other_prop_info.force or 0);

	self.leftRatioList:setLocation(-215, -117);
	self.rightRatioList:setLocation(146, -82);
	self.leftCount = self.leftCount < 1 and 1 or self.leftCount;
	self.leftBg:SetDimensions(341, 309 + self.leftCount * self.itemHeight)
	self.rightCount = self.rightCount < 1 and 1 or self.rightCount;
	self.rightBg:SetDimensions(341, 275 + self.rightCount * self.itemHeight)
end










----------------------------------神器----------------------------------------------
Lua_ForceRatioTypeAttributeArtfactPanel = class("Lua_ForceRatioTypeAttributeArtfactPanel", Lua_ForceRatioTypeAttributeBasePanel);
function Lua_ForceRatioTypeAttributeArtfactPanel:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributeArtfactPanel_skin");
end

function Lua_ForceRatioTypeAttributeArtfactPanel:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ForceRatioTypeAttributeArtfactPanel:dispose()
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeArtfactPanel:setData(data, ratioType)
	self:superCall("setData", data, ratioType);
	if data == nil then
		return;
	end

	self.ratioType = ratioType;

	self.leftTitleTxt:setLangValue(162024);
	self.leftDescTxt_2:setLangValue(162025);
	local forceValue = data.self_prop_info ~= nil and data.self_prop_info.force or 0;
	self.leftDescTxt.text = LanUtil.formateStr(162026, forceValue);


	self.rightTitleTxt:setLangValue(162024);
	self.rightDescTxt_2:setLangValue(162025);
	forceValue = data.other_prop_info ~= nil and data.other_prop_info.force or 0;
	self.rightDescTxt.text = LanUtil.formateStr(162026, forceValue);

	self.leftRatioList:setLocation(-215, 15);
	self.rightRatioList:setLocation(146, 15);
	self.leftCount = self.leftCount < 1 and 1 or self.leftCount;
	self.leftBg:SetDimensions(341, 182 + self.leftCount * self.itemHeight)
	self.rightCount = self.rightCount < 1 and 1 or self.rightCount;
	self.rightBg:SetDimensions(341, 182 + self.rightCount * self.itemHeight)
end









----------------------------------称号----------------------------------------------
Lua_ForceRatioTypeAttributePersonTitlePanel = class("Lua_ForceRatioTypeAttributePersonTitlePanel", Lua_ForceRatioTypeAttributeBasePanel);
function Lua_ForceRatioTypeAttributePersonTitlePanel:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributePersonTitlePanel_skin");
end

function Lua_ForceRatioTypeAttributePersonTitlePanel:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ForceRatioTypeAttributePersonTitlePanel:dispose()
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributePersonTitlePanel:setData(data, ratioType)
	self:superCall("setData", data, ratioType);
	if data == nil then
		return;
	end

	self.ratioType = ratioType;

	self.leftTitleTxt:setLangValue(162024);
	self.rightTitleTxt:setLangValue(162024);
	
	local leftStr, rightStr;
	local leftValue = DataCenter.friendData:getForceRatioValue(Lua_FriendUtil.PERSONTITLE, false);
	local rightValue = DataCenter.friendData:getForceRatioValue(Lua_FriendUtil.PERSONTITLE, true);
	if leftValue == nil then
		leftStr = LanUtil.getValue(162003)
	elseif leftValue == 0 then
		leftStr = LanUtil.getValue(162036);
	end
	if rightValue == nil then
		rightStr = LanUtil.getValue(162003)
	elseif rightValue == 0 then
		rightStr = LanUtil.getValue(162036);
	end
	self.leftDescTxt_2.text = leftStr;
	self.rightDescTxt_2.text = rightStr;
	self.leftDescTxt.text = LanUtil.formateStr(162026,data.self_prop_info.force or 0);
	self.rightDescTxt.text = LanUtil.formateStr(162026, data.other_prop_info.force or 0);


	self.leftRatioList:setLocation(-215, 15);
	self.rightRatioList:setLocation(146, 15);
	self.leftCount = self.leftCount < 1 and 1 or self.leftCount;
	self.leftBg:SetDimensions(341, 182 + self.leftCount * self.itemHeight)
	self.rightCount = self.rightCount < 1 and 1 or self.rightCount;
	self.rightBg:SetDimensions(341, 182 + self.rightCount * self.itemHeight)
end











----------------------------------公会----------------------------------------------
Lua_ForceRatioTypeAttributeLeagueLevelPanel = class("Lua_ForceRatioTypeAttributeLeagueLevelPanel", Lua_ForceRatioTypeAttributeBasePanel);
function Lua_ForceRatioTypeAttributeLeagueLevelPanel:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributeLeagueLevelPanel_skin");
end

function Lua_ForceRatioTypeAttributeLeagueLevelPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.gotoTxt:addClickFuntion(self, self.onClickGotoTxt);
end

function Lua_ForceRatioTypeAttributeLeagueLevelPanel:dispose()
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeLeagueLevelPanel:setData(data, ratioType)
	self:superCall("setData", data, ratioType);
	if data == nil then
		return;
	end

	self.ratioType = ratioType;

	self.leftTitleTxt:setLangValue(162016);
	self.leftDescTxt_2:setLangValue(162024);
	self.leftDescTxt_4:setLangValue(162017);
	self.leftDescTxt_3.text = LanUtil.formateStr(162026,data.self_prop_info.force or 0);

	self.rightTitleTxt:setLangValue(162016);
	self.rightDescTxt_2:setLangValue(162024);
	self.rightDescTxt_4:setLangValue(162017);
	self.rightDescTxt_3.text = LanUtil.formateStr(162026, data.other_prop_info.force or 0);

	-- 公会名称
	local str = "";
	if DataCenter.roleData:isJoinTheLeague() then
		str = LanUtil.formateStr(162018, DataCenter.roleData.league_name, DataCenter.roleData.league_level);
	else
		str = LanUtil.getValue(162019);
	end
	self.leftDescTxt.text = str;

	str = "";
	local otherPlayerInfo = DataCenter.friendData.otherPlayerInfo;
	local league_id = otherPlayerInfo.league_id;
	league_id = league_id ~= nil and tonumber(league_id) or league_id;
	if league_id ~= nil and league_id > 0 then
		str = LanUtil.formateStr(162018, otherPlayerInfo.league_name, otherPlayerInfo.league_level);
	else
		str = LanUtil.getValue(162019);
	end
	self.rightDescTxt.text = str;

	self.leftRatioList:setLocation(-215, -117);
	self.rightRatioList:setLocation(146, -82);
	self.leftCount = self.leftCount < 1 and 1 or self.leftCount;
	self.leftBg:SetDimensions(341, 309 + self.leftCount * self.itemHeight)
	self.rightCount = self.rightCount < 1 and 1 or self.rightCount;
	self.rightBg:SetDimensions(341, 275 + self.rightCount * self.itemHeight)
end









----------------------------------藏品柜----------------------------------------------
Lua_ForceRatioTypeAttributeCollectionItemPanel = class("Lua_ForceRatioTypeAttributeCollectionItemPanel", Lua_ForceRatioTypeAttributeBasePanel);
function Lua_ForceRatioTypeAttributeCollectionItemPanel:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributeCollectionItemPanel_skin");
end

function Lua_ForceRatioTypeAttributeCollectionItemPanel:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ForceRatioTypeAttributeCollectionItemPanel:dispose()
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeCollectionItemPanel:setData(data, ratioType)
	self:superCall("setData", data, ratioType);
	if data == nil then
		return;
	end

	self.ratioType = ratioType;

	self.leftTitleTxt:setLangValue(162007);
	self.rightTitleTxt:setLangValue(162007);
	self.leftDescTxt_1:setLangValue(162008);
	self.rightDescTxt_1:setLangValue(162008)
	

	local lvl = data.self_prop_info ~= nil and data.self_prop_info.value or 0;
	self.leftDescTxt.text = LanUtil.formateStr(162009, lvl);
	lvl = data.other_prop_info ~= nil and data.other_prop_info.value or 0;
	self.rightDescTxt.text = LanUtil.formateStr(162009, lvl);

	self.leftRatioList:setLocation(-215, 15);
	self.rightRatioList:setLocation(146, 15);
	self.leftCount = self.leftCount < 1 and 1 or self.leftCount;
	self.leftBg:SetDimensions(341, 182 + self.leftCount * self.itemHeight)
	self.rightCount = self.rightCount < 1 and 1 or self.rightCount;
	self.rightBg:SetDimensions(341, 182 + self.rightCount * self.itemHeight)
end





----------------------------------同调器----------------------------------------------
Lua_ForceRatioTypeAttributeHomologatorPanel = class("Lua_ForceRatioTypeAttributeHomologatorPanel", Lua_ForceRatioTypeAttributeBasePanel);
function Lua_ForceRatioTypeAttributeHomologatorPanel:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributeHomologatorPanel_skin");
end

function Lua_ForceRatioTypeAttributeHomologatorPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.gotoTxt:addClickFuntion(self, self.onClickGotoTxt);
end

function Lua_ForceRatioTypeAttributeHomologatorPanel:dispose()
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeHomologatorPanel:setData(data, ratioType)
	self:superCall("setData", data, ratioType);
	if data == nil then
		return;
	end

	self.ratioType = ratioType;

	self.leftTitleTxt:setLangValue(162024);
	self.rightTitleTxt:setLangValue(162024);
	self.leftDescTxt_1:setLangValue(162010);
	self.rightDescTxt_1:setLangValue(162010);

	self.leftDescTxt.text = LanUtil.formateStr(162026, data.self_prop_info ~= nil and data.self_prop_info.force or 0);
	self.rightDescTxt.text = LanUtil.formateStr(162026, data.other_prop_info ~= nil and data.other_prop_info.force or 0);

	self.leftRatioList:setLocation(-215, -21);
	self.rightRatioList:setLocation(146, 15);
	self.leftCount = self.leftCount < 1 and 1 or self.leftCount;
	self.leftBg:SetDimensions(341, 216 + self.leftCount * self.itemHeight)
	self.rightCount = self.rightCount < 1 and 1 or self.rightCount;
	self.rightBg:SetDimensions(341, 182 + self.rightCount * self.itemHeight)
end












----------------------------------公会技巧----------------------------------------------
Lua_ForceRatioTypeAttributeLeagueSkillPanel = class("Lua_ForceRatioTypeAttributeLeagueSkillPanel", Lua_DisplayObject);
function Lua_ForceRatioTypeAttributeLeagueSkillPanel:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributeLeagueSkillPanel_skin");
end

function Lua_ForceRatioTypeAttributeLeagueSkillPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.leftDragContainer = Lua_DragContainer.new(self.leftObj, 333, 188, Lua_AxisDefine.Vertical);
	self.leftDragContainer:setLocation(0, -199, 0);
	self.leftDragContainer:setRectPivot(1);
	self.leftDragContainer:setRectAnchor(1);

	self.rightDragContainer = Lua_DragContainer.new(self.rightObj, 333, 188, Lua_AxisDefine.Vertical);
	self.rightDragContainer:setLocation(0, -164, 0);
	self.rightDragContainer:setRectPivot(1);
	self.rightDragContainer:setRectAnchor(1);

	self.gotoTxt:addClickFuntion(self, self.onClickGotoTxt);
end

function Lua_ForceRatioTypeAttributeLeagueSkillPanel:dispose()
	if self.leftDragContainer ~= nil then
		self.leftDragContainer:dispose();
		self.leftDragContainer = nil;
	end
	if self.rightDragContainer ~= nil then
		self.rightDragContainer:dispose();
		self.rightDragContainer = nil;
	end
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeLeagueSkillPanel:onClickGotoTxt()
	local bCloseOther = false;
	if self.ratioType == Lua_FriendUtil.LEAGUESKILL  -- 公会技巧
	then
		bCloseOther = true;
	end
	local funcPathId_1 = DataCenter.friendUtil:getRatioCfgAtt(self.ratioType, 9);

	if funcPathId_1 ~= nil then
		DataCenter.funcPathUtil:gotoFunction(funcPathId_1, bCloseOther);
	end
end

function Lua_ForceRatioTypeAttributeLeagueSkillPanel:setData(param, ratioType)
	if ratioType == nil then
		return;
	end

	self.ratioType = ratioType;

	self.leftTitleTxt:setLangValue(162024);
	self.rightTitleTxt:setLangValue(162024);
	self.leftDescTxt_1:setLangValue(162014);
	self.rightDescTxt_1:setLangValue(162014);

	self.leftDescTxt.text = LanUtil.formateStr(162026, DataCenter.friendData.myselfLeagueSkillForce);
	self.rightDescTxt.text = LanUtil.formateStr(162026, DataCenter.friendData.otherLeagueSkillDirForce);


	local cell;
	local leftHeight, rightHeight = 0, 0;
	self.leftDragContainer:clearList();
	self.rightDragContainer:clearList();
	local careerList = DataCenter.allianceUtil:getConstConfig("science_career_sort", 5);
	for i = 1, #careerList do
		self.leftDragContainer:addSubContainer(Lua_ForceRatioTypeAttributeLeagueSkillItem, {id = careerList[i], bMyself = true }, false);
		self.rightDragContainer:addSubContainer(Lua_ForceRatioTypeAttributeLeagueSkillItem, {id = careerList[i], bMyself = false }, false);

		cell = self.leftDragContainer.showDragDataList:getItem(i);
		leftHeight = leftHeight + (cell ~= nil and cell.cellHeight or 0);
		cell = self.rightDragContainer.showDragDataList:getItem(i);
		rightHeight = rightHeight + (cell ~= nil and cell.cellHeight or 0);
	end

	self.leftDragContainer:updateChildPos();
	self.leftDragContainer:setContentRect(333, leftHeight);
	self.rightDragContainer:updateChildPos();
	self.rightDragContainer:setContentRect(333, rightHeight);

	self.leftBg:SetDimensions(353, 216 + leftHeight);
	self.rightBg:SetDimensions(353, 180 + rightHeight);
	LuaUtil.setRectSize(self.leftObj, 353, 216 + leftHeight);
	LuaUtil.setRectSize(self.rightObj, 353, 180 + rightHeight);
end







---------------------------------

Lua_ForceRatioTypeAttributeLeagueSkillItem = class("Lua_ForceRatioTypeAttributeLeagueSkillItem", Lua_DragContainerItem);
function Lua_ForceRatioTypeAttributeLeagueSkillItem:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributeLeagueSkillItem_skin");
end

function Lua_ForceRatioTypeAttributeLeagueSkillItem:buildShowItem()
	self:superCall("buildShowItem");

	self.itemHeight = 30;
end

function Lua_ForceRatioTypeAttributeLeagueSkillItem:dispose()
	if self.descItems ~= nil then
		for i = 1, #self.descItems do
			self.descItems[i]:dispose();
			self.descItems[i] = nil;
		end
		self.descItems = nil;
	end
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeLeagueSkillItem:setData(data)
	if data == nil then
		return;
	end

	local id = data.id;
	local str;
	if id == 1 then
		str = 162043;
	elseif id == 2 then
		str = 162044;
	elseif id == 3 then
		str = 162045;
	elseif id == 4 then
		str = 162046;
	end

	local info = DataCenter.friendData:getLeagueSkillInfo(id, data.bMyself);
	local propArr = DataCenter.attributesUtil:getAttrArrByServer(info ~= nil and info.prop_info or nil);
	self.rightTitleTxt.text = LanUtil.formateStr(str, info ~= nil and info.level or 0);
	self:updateItems(propArr);

	local showStr = propArr ~= nil and propArr:getSize() <= 0 and LanUtil.getValue(162047) or nil;
	self.nonDescTxt.text = showStr;
end

function Lua_ForceRatioTypeAttributeLeagueSkillItem:updateItems(propArr)
	if self.descItems == nil then
		self.descItems = {};
	end

	local item;
	local startPosX, startPosY = -30, -47;
	local posX, posY = 0, 0;
	local distanceX, distanceY = 155, self.itemHeight;
	local row,col;
	local index;
	local arr = propArr;
	self.len = arr:getSize();
	for i = 1, self.len do
		item = self.descItems[i];
		if item == nil then
			item = Lua_ForceRatioTypeAttributeLeagueSkillSubItem.new(self.content);
			item:setRectAnchor(1);
			self.descItems[i] = item;
		end

		index = i - 1;
		row = Mathf.Floor(index / 2);
		col = index % 2;
		posX = startPosX + col * distanceX;
		posY = startPosY - row * distanceY;
		item:setLocation(posX, posY);
		item:setData(arr[i]);
		item:setEnable(true);
	end

	if self.len < #self.descItems then
		for i = self.len + 1, #self.descItems do
			item = self.descItems[i];
			item:setEnable(false);
		end
	end
end

function Lua_ForceRatioTypeAttributeLeagueSkillItem:getWidth()
    return 188;
end

function Lua_ForceRatioTypeAttributeLeagueSkillItem:getHeight()
    local count = self.len ~= nil and self.len or 1; 
    count = count < 1 and 1 or Mathf.Ceil(count / 2);
    return 48 + count * self.itemHeight;
end





---------------------------------------------------------------
Lua_ForceRatioTypeAttributeLeagueSkillSubItem = class("Lua_ForceRatioTypeAttributeLeagueSkillSubItem", Lua_DisplayObject);
function Lua_ForceRatioTypeAttributeLeagueSkillSubItem:ctor(p)
	self:superCall("ctor", p, "ForceRatioTypeAttributeLeagueSkillSubItem_skin");
end

function Lua_ForceRatioTypeAttributeLeagueSkillSubItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_ForceRatioTypeAttributeLeagueSkillSubItem:dispose()
	self:superCall("dispose");
end

function Lua_ForceRatioTypeAttributeLeagueSkillSubItem:setData(data)
	self.data = data;

	if data == nil then
		return;
	end

	local str = LanUtil.formateStr(162049, data.show_name, data.showValue);
	self.descTxt.text = str;
end